--[[
Copyright 2010, 2011 William Matthews. All rights reserved.

See LICENSE for license terms.
]]

local CB = select(2,...)
local P = CB.Private
local Mail = P:NewModule("Mail", "AceEvent-3.0")
local L = P.L

local function prehookfunc(name,hook)
	local real = _G[name]
	local function f(...)
		hook(...)
		return real(...)
	end
	_G[name]=f
end	

local expiredLocale = AUCTION_EXPIRED_MAIL_SUBJECT:gsub("%%s", "(.+)")
local salePendingLocale = AUCTION_INVOICE_MAIL_SUBJECT:gsub("%%s", "(.+)") --sale pending
local outbidLocale = AUCTION_OUTBID_MAIL_SUBJECT:gsub("%%s", "(.+)")
local cancelledLocale = AUCTION_REMOVED_MAIL_SUBJECT:gsub("%%s", "(.+)")
local successLocale = AUCTION_SOLD_MAIL_SUBJECT:gsub("%%s", "(.+)")
local wonLocale = AUCTION_WON_MAIL_SUBJECT:gsub("%%s", "(.+)")

local function doAHMail(mailID,attachmentIndex)
	local _, _, sender, subject, money, CODAmount, daysLeft, itemCount, wasRead, wasReturned, textCreated, canReply, isGM, itemQuantity = GetInboxHeaderInfo(mailID)
	local itemLink = GetInboxItemLink(mailID, attachmentIndex)
	local _, _, count, _, _ = GetInboxItem(mailID, attachmentIndex)
	if sender == L["Auction House"] or
	   sender == L["Alliance Auction House"] or
	   sender == L["Horde Auction House"] or
	   sender == L["Blackwater Auction House"] then
		if subject:match(wonLocale) then
			local invoiceType, itemName, playerName, bid, buyout, deposit, consignment, moneyDelay, etaHour, etaMin = GetInboxInvoiceInfo(mailID)
			if itemLink and count and invoiceType and bid and bid > 0 then -- and playerName and playerName ~= ""
				local id=P.idOfItem(itemLink)
				P:ReceiveCallback(id,count,
					function() 
						CB:RecordTransaction(bid,nil,{[id]=count})
					end,
					function()
						P:DebugPrint("failed to receive mail item")
					end)
			else
				P:Print(format("GetInboxInvoiceInfo(%d) returned junk.  Cannot compute CB!",mailID))
			end
		end
	end
end

-- Hook looting items from mailbox
local function Hook_TakeInboxItem(mailID,attachmentIndex)
	doAHMail(mailID,attachmentIndex)
end
prehookfunc("TakeInboxItem",Hook_TakeInboxItem)

local function Hook_AutoLootMailItem(mailID)
	doAHMail(mailID,1)
end
prehookfunc("AutoLootMailItem",Hook_AutoLootMailItem)

